From d11971adf8dca1de33bf7ea4bd3c09e2f90ab7b6 Mon Sep 17 00:00:00 2001
From: Gabriele Musco <gabmus@disroot.org>
Date: Wed, 12 Apr 2023 07:32:56 +0200
Subject: [PATCH 11/11] update dependencies; remove daemon; use poetry for
 dependencies

---
 COPYING                                       | 675 ------------------
 bin/hydrapaper.in                             |   4 -
 bin/meson.build                               |   6 -
 data/meson.build                              |  34 -
 data/org.gabmus.hydrapaper.Daemon.desktop.in  |  10 -
 data/org.gabmus.hydrapaper.Daemon.service.in  |   3 -
 ...abmus.hydrapaper.Daemon.service.systemd.in |   7 -
 dist/flatpak/org.gabmus.hydrapaper.json       |  42 +-
 dist/flatpak/python-deps.json                 |  19 +
 hydrapaper/__main__.py                        |  14 +-
 hydrapaper/app_window.py                      |  14 +-
 hydrapaper/apply_wallpapers.py                |   6 +-
 hydrapaper/base_preferences.py                |   2 +-
 hydrapaper/confManager.py                     |   2 +-
 hydrapaper/daemon_helper.py                   |   4 -
 hydrapaper/folder_store.py                    |   2 +-
 hydrapaper/headerbar.py                       |  28 +-
 hydrapaper/main_stack.py                      |   4 +-
 hydrapaper/monitor_parser.py                  |   8 +-
 hydrapaper/monitors_flowbox.py                |   6 +-
 hydrapaper/preferences_window.py              |  75 +-
 hydrapaper/slideshow_listbox_row.py           |   2 +-
 hydrapaper/wallpaper_flowbox_item.py          |   2 +-
 hydrapaper/wallpaper_merger.py                |   2 +-
 hydrapaper/wallpapers_flowbox.py              |   6 +-
 hydrapaper/wallpapers_folder_listbox_row.py   |   4 +-
 hydrapaper/wallpapers_folders_view.py         |   8 +-
 hydrapaper_daemon/hydrapaperd.in.py           | 237 ------
 hydrapaper_daemon/meson.build                 |  10 -
 meson.build                                   |   6 -
 meson_options.txt                             |   5 -
 poetry.lock                                   |  97 +++
 pyproject.toml                                |  16 +
 33 files changed, 188 insertions(+), 1172 deletions(-)
 delete mode 100644 COPYING
 delete mode 100644 data/org.gabmus.hydrapaper.Daemon.desktop.in
 delete mode 100644 data/org.gabmus.hydrapaper.Daemon.service.in
 delete mode 100644 data/org.gabmus.hydrapaper.Daemon.service.systemd.in
 create mode 100644 dist/flatpak/python-deps.json
 delete mode 100644 hydrapaper/daemon_helper.py
 delete mode 100755 hydrapaper_daemon/hydrapaperd.in.py
 delete mode 100644 hydrapaper_daemon/meson.build
 delete mode 100644 meson_options.txt
 create mode 100644 poetry.lock
 create mode 100644 pyproject.toml

diff --git a/bin/hydrapaper.in b/bin/hydrapaper.in
index ab526ee..7d5aad0 100755
--- a/bin/hydrapaper.in
+++ b/bin/hydrapaper.in
@@ -66,9 +66,5 @@ if __name__ == '__main__':
     resource = Gio.Resource.load(os.path.join(pkgdatadir, '@appid@.gresource'))
     resource._register()
 
-    from hydrapaper import daemon_helper
-    daemon_helper.APPLICATIONS_DIR = '@applications_dir@'
-    daemon_helper.DAEMON_BUILD_ENABLED = @enable_daemon@
-
     from @projectname@ import __main__
     __main__.main()
diff --git a/bin/meson.build b/bin/meson.build
index 6c04d03..806f831 100644
--- a/bin/meson.build
+++ b/bin/meson.build
@@ -9,12 +9,6 @@ conf.set('projectname', meson.project_name())
 conf.set('authorfullname', authorfullname)
 conf.set('authoremail', authoremail)
 conf.set('appid', '.'.join([domain, author, meson.project_name()]))
-conf.set('applications_dir', join_paths(prefix, datadir, 'applications'))
-if enable_daemon == true
-    conf.set('enable_daemon', 'True')
-else
-    conf.set('enable_daemon', 'False')
-endif
 
 configure_file(
   input: meson.project_name() + '.in',
diff --git a/data/meson.build b/data/meson.build
index 2f80fed..fc2645e 100644
--- a/data/meson.build
+++ b/data/meson.build
@@ -28,40 +28,6 @@ configure_file(
     install_dir: dbus_service_dir
 )
 
-if enable_daemon
-    configure_file(
-        input: app_id + '.Daemon.service.in',
-        output: app_id + '.Daemon.service',
-        configuration: conf,
-        install: true,
-        install_dir: dbus_service_dir
-    )
-
-    configure_file(
-        input: app_id + '.Daemon.service.systemd.in',
-        output: app_id + 'd.service',
-        configuration: conf,
-        install: true,
-        install_dir: systemd_user_unit_dir
-    )
-
-    daemon_desktop_file = configure_file(
-        input: app_id + '.Daemon.desktop.in',
-        output: app_id + '.Daemon.desktop.i18n.in',
-        configuration: conf
-    )
-
-    i18n.merge_file(
-        input: daemon_desktop_file,
-        output: app_id + '.Daemon.desktop',
-        po_dir: '../po',
-        type: 'desktop',
-        install: true,
-        # install_dir: join_paths(etcdir, 'xdg', 'autostart')
-        install_dir: join_paths(datadir, 'applications')
-    )
-endif
-
 configure_file(
     input: app_id + '.gschema.xml.in',
     output: app_id + '.gschema.xml',
diff --git a/hydrapaper/__main__.py b/hydrapaper/__main__.py
index 7f0a392..24ae926 100644
--- a/hydrapaper/__main__.py
+++ b/hydrapaper/__main__.py
@@ -2,13 +2,13 @@ from gettext import gettext as _
 import sys
 import argparse
 from gi.repository import Gtk, Gio, GLib
-from .confManager import ConfManager
-from .app_window import HydraPaperAppWindow
-from .preferences_window import PreferencesWindow
-from .is_image import is_image
-from .monitor_parser import build_monitors_autodetect
-from .apply_wallpapers import apply_wallpapers
-from .base_app import BaseApp, AppAction
+from hydrapaper.confManager import ConfManager
+from hydrapaper.app_window import HydraPaperAppWindow
+from hydrapaper.preferences_window import PreferencesWindow
+from hydrapaper.is_image import is_image
+from hydrapaper.monitor_parser import build_monitors_autodetect
+from hydrapaper.apply_wallpapers import apply_wallpapers
+from hydrapaper.base_app import BaseApp, AppAction
 
 
 class HydraPaperApplication(BaseApp):
diff --git a/hydrapaper/app_window.py b/hydrapaper/app_window.py
index f4679d3..f40569e 100644
--- a/hydrapaper/app_window.py
+++ b/hydrapaper/app_window.py
@@ -1,11 +1,11 @@
 from gi.repository import Gtk, Adw
-from .confManager import ConfManager
-from .main_stack import HydraPaperMainStack
-from .monitors_flowbox import HydraPaperMonitorsFlowbox
-from .apply_wallpapers import apply_wallpapers
-from .headerbar import HydraPaperHeaderbar
-from .base_app import BaseWindow, AppShortcut
-from .search_bar import HpSearchBar
+from hydrapaper.confManager import ConfManager
+from hydrapaper.main_stack import HydraPaperMainStack
+from hydrapaper.monitors_flowbox import HydraPaperMonitorsFlowbox
+from hydrapaper.apply_wallpapers import apply_wallpapers
+from hydrapaper.headerbar import HydraPaperHeaderbar
+from hydrapaper.base_app import BaseWindow, AppShortcut
+from hydrapaper.search_bar import HpSearchBar
 
 
 class HydraPaperAppWindow(BaseWindow):
diff --git a/hydrapaper/apply_wallpapers.py b/hydrapaper/apply_wallpapers.py
index 4aa4bfa..ea9aa31 100644
--- a/hydrapaper/apply_wallpapers.py
+++ b/hydrapaper/apply_wallpapers.py
@@ -2,7 +2,7 @@ from threading import Thread
 from gi.repository import GLib
 from hashlib import sha256
 from os.path import isfile
-from .wallpaper_merger import (
+from hydrapaper.wallpaper_merger import (
     set_wallpaper_gnome,
     set_wallpaper_cinnamon,
     set_wallpaper_mate,
@@ -10,8 +10,8 @@ from .wallpaper_merger import (
     multi_setup_pillow,
     # cut_image
 )
-from .confManager import ConfManager
-from .get_desktop_environment import get_desktop_environment
+from hydrapaper.confManager import ConfManager
+from hydrapaper.get_desktop_environment import get_desktop_environment
 
 
 def widgets_set_sensitive(widgets, state: bool):
diff --git a/hydrapaper/base_preferences.py b/hydrapaper/base_preferences.py
index ea57d5d..9812470 100644
--- a/hydrapaper/base_preferences.py
+++ b/hydrapaper/base_preferences.py
@@ -1,6 +1,6 @@
 from gettext import gettext as _
-from .confManager import ConfManager
 from gi.repository import Gtk, Adw, Gio, GObject
+from hydrapaper.confManager import ConfManager
 from typing import Optional, Union, List, Callable
 
 
diff --git a/hydrapaper/confManager.py b/hydrapaper/confManager.py
index 6b62eea..ba5b067 100644
--- a/hydrapaper/confManager.py
+++ b/hydrapaper/confManager.py
@@ -79,7 +79,7 @@ class ConfManager(metaclass=Singleton):
             'width': 600,
             'height': 400
         },
-        'enable_daemon': True,
+        'enable_daemon': False,
         'last_wps': {
             'spanned': False,
             'wps': {}
diff --git a/hydrapaper/folder_store.py b/hydrapaper/folder_store.py
index 9e3ddd2..7a88da6 100644
--- a/hydrapaper/folder_store.py
+++ b/hydrapaper/folder_store.py
@@ -1,7 +1,7 @@
 from pathlib import Path
 from typing import List, Union
 from gi.repository import Gtk, Gio, GObject
-from .confManager import ConfManager
+from hydrapaper.confManager import ConfManager
 
 
 class FolderObj(GObject.Object):
diff --git a/hydrapaper/headerbar.py b/hydrapaper/headerbar.py
index 9ddcf8d..2c280a9 100644
--- a/hydrapaper/headerbar.py
+++ b/hydrapaper/headerbar.py
@@ -1,10 +1,8 @@
 from gi.repository import Gtk
-from .get_desktop_environment import get_desktop_environment
-from .wallpapers_folders_view import HydraPaperWallpapersFoldersView
-from .confManager import ConfManager
-from .slideshow_listbox_row import SlideshowListboxRow
-from .daemon_helper import DAEMON_BUILD_ENABLED
-import dbus
+from hydrapaper.get_desktop_environment import get_desktop_environment
+from hydrapaper.wallpapers_folders_view import HydraPaperWallpapersFoldersView
+from hydrapaper.confManager import ConfManager
+from hydrapaper.slideshow_listbox_row import SlideshowListboxRow
 
 
 @Gtk.Template(resource_path='/org/gabmus/hydrapaper/ui/headerbar.ui')
@@ -44,7 +42,7 @@ class HydraPaperHeaderbar(Gtk.WindowHandle):
                 )
         )
 
-        if not DAEMON_BUILD_ENABLED:
+        if True:  # TODO: rework background worker
             self.slideshow_menu_btn.set_visible(False)
         self.slideshow_switch.set_state(
             self.confman.conf['Daemon']['wallpaper_rotation_enabled']
@@ -64,20 +62,8 @@ class HydraPaperHeaderbar(Gtk.WindowHandle):
         )
 
     def signal_daemon(self):
-        if not DAEMON_BUILD_ENABLED:
+        if True:  # TODO: rework background worker
             return
-        try:
-            bus = dbus.SessionBus()
-            d = bus.get_object(
-                'org.gabmus.hydrapaper.Daemon',
-                '/org/gabmus/hydrapaper/Daemon'
-            )
-            iface = dbus.Interface(
-                d, dbus_interface='org.gabmus.hydrapaper.Daemon'
-            )
-            iface.update_config()
-        except dbus.exceptions.DBusException:
-            print('Failed to communicate with HydraPaper daemon')
 
     @Gtk.Template.Callback()
     def on_slideshow_time_spinbutton_changed(self, *args):
@@ -115,7 +101,7 @@ class HydraPaperHeaderbar(Gtk.WindowHandle):
     @Gtk.Template.Callback()
     def on_slideshow_mode_changed(self, *args):
         n_state = self.slideshow_switch.get_active()
-        if not DAEMON_BUILD_ENABLED:
+        if True:  # TODO: rework background worker
             n_state = False
         self.confman.conf['Daemon']['wallpaper_rotation_enabled'] = n_state
         self.confman.save_conf_async()
diff --git a/hydrapaper/main_stack.py b/hydrapaper/main_stack.py
index 8f1c57f..3afb5ca 100644
--- a/hydrapaper/main_stack.py
+++ b/hydrapaper/main_stack.py
@@ -1,7 +1,7 @@
 from gettext import gettext as _
 from gi.repository import Adw
-from .wallpapers_flowbox import HydraPaperWallpapersFlowbox
-from .search_bar import HpSearchBar
+from hydrapaper.wallpapers_flowbox import HydraPaperWallpapersFlowbox
+from hydrapaper.search_bar import HpSearchBar
 
 
 class HydraPaperMainStack(Adw.Bin):
diff --git a/hydrapaper/monitor_parser.py b/hydrapaper/monitor_parser.py
index 8a8afda..c2aed43 100644
--- a/hydrapaper/monitor_parser.py
+++ b/hydrapaper/monitor_parser.py
@@ -2,11 +2,11 @@ from gettext import gettext as _
 from gi.repository import Gdk
 from subprocess import run, PIPE
 import json
-from .get_desktop_environment import get_desktop_environment
-from .confManager import ConfManager
-from .wallpaper_merger import get_combined_resolution
-import dbus
+from hydrapaper.get_desktop_environment import get_desktop_environment
+from hydrapaper.confManager import ConfManager
+from hydrapaper.wallpaper_merger import get_combined_resolution
 from os import environ as Env
+import dbus
 
 
 confman = ConfManager()
diff --git a/hydrapaper/monitors_flowbox.py b/hydrapaper/monitors_flowbox.py
index 614d295..49de5dc 100644
--- a/hydrapaper/monitors_flowbox.py
+++ b/hydrapaper/monitors_flowbox.py
@@ -1,10 +1,10 @@
 from gi.repository import Gtk, GdkPixbuf
-from .confManager import ConfManager
-from .monitor_parser import (
+from hydrapaper.confManager import ConfManager
+from hydrapaper.monitor_parser import (
     build_monitors_autodetect,
     build_combined_spanned_monitor
 )
-from .is_image import is_image
+from hydrapaper.is_image import is_image
 from hashlib import sha256
 from os.path import isfile
 
diff --git a/hydrapaper/preferences_window.py b/hydrapaper/preferences_window.py
index 3174d04..09459be 100644
--- a/hydrapaper/preferences_window.py
+++ b/hydrapaper/preferences_window.py
@@ -4,74 +4,13 @@ from os.path import isfile, abspath, join
 from os import remove, listdir
 from os import environ as Env
 from subprocess import run
-from .daemon_helper import APPLICATIONS_DIR, DAEMON_BUILD_ENABLED
-from .base_preferences import (
+from hydrapaper.base_preferences import (
     MPreferencesPage, MPreferencesGroup,
     PreferencesButtonRow, PreferencesToggleRow
 )
 from typing import Optional
 
 
-class AutostartToggleRow(PreferencesToggleRow):
-    def __init__(self):
-        super().__init__(
-            title=_('Start daemon on login'),
-            subtitle=_('React to monitor changes and start slideshow mode'),
-            conf_key=None
-        )
-        self.source_file = \
-            f'{APPLICATIONS_DIR}/org.gabmus.hydrapaper.Daemon.desktop'
-        self.autostart_dir = \
-            f'{Env.get("HOME")}/.config/autostart'
-        self.target_file = \
-            f'{self.autostart_dir}/org.gabmus.hydrapaper.Daemon.desktop'
-        self.toggle.set_active(self.target_exists())
-
-    def target_exists(self):
-        if isfile(self.target_file):
-            with open(self.target_file, 'r') as fd:
-                if fd.read().strip() != self.get_daemon_desktop_file().strip():
-                    self.create_autostart()
-                return True
-        return False
-
-    def get_daemon_desktop_file(self):
-        res = ''
-        with open(self.source_file, 'r') as fd:
-            res = fd.read()
-        if self.confman.is_flatpak:
-            res = res.replace(
-                '/app/libexec/hydrapaperd',
-                '/usr/bin/flatpak run --command=/app/libexec/hydrapaperd '
-                'org.gabmus.hydrapaper'
-            )
-        return res
-
-    def create_autostart(self):
-        self.delete_autostart()
-        cmds = [
-            f'mkdir -p {self.autostart_dir}',
-            (
-                f"cat <<'EOF' >> {self.target_file}\n"
-                f"{self.get_daemon_desktop_file()}\nEOF"
-            )
-        ]
-        for cmd in cmds:
-            if self.confman.is_flatpak:
-                cmd = 'flatpak-spawn --host ' + cmd
-            run(cmd, shell=True)
-
-    def delete_autostart(self):
-        if isfile(self.target_file):
-            remove(self.target_file)
-
-    def on_toggle_state_set(self, toggle, state):
-        if state:
-            self.create_autostart()
-        else:
-            self.delete_autostart()
-
-
 class GeneralPreferencesPage(MPreferencesPage):
     def __init__(self):
         general_rows = [
@@ -85,18 +24,6 @@ class GeneralPreferencesPage(MPreferencesPage):
                 conf_key='random_wallpapers_names'
             )
         ]
-        if DAEMON_BUILD_ENABLED:
-            general_rows.append(
-                PreferencesToggleRow(
-                    title=_('Enable daemon'),
-                    subtitle=_(
-                        'Needed for slideshow mode and to detect display '
-                        'changes'
-                    ),
-                    conf_key='enable_daemon'
-                )
-            )
-            general_rows.append(AutostartToggleRow())
         super().__init__(
             title=_('General'), icon_name='preferences-other-symbolic',
             pref_groups=[
diff --git a/hydrapaper/slideshow_listbox_row.py b/hydrapaper/slideshow_listbox_row.py
index a852039..270fa9d 100644
--- a/hydrapaper/slideshow_listbox_row.py
+++ b/hydrapaper/slideshow_listbox_row.py
@@ -1,7 +1,7 @@
 from gettext import gettext as _
 from gi.repository import Gtk
 from os.path import isfile
-from .confManager import ConfManager
+from hydrapaper.confManager import ConfManager
 
 
 class SlideshowListboxRow(Gtk.ListBoxRow):
diff --git a/hydrapaper/wallpaper_flowbox_item.py b/hydrapaper/wallpaper_flowbox_item.py
index f0fcac0..fef0905 100644
--- a/hydrapaper/wallpaper_flowbox_item.py
+++ b/hydrapaper/wallpaper_flowbox_item.py
@@ -3,7 +3,7 @@ from gi.repository import Gtk, GLib
 import os
 from PIL import Image
 from hashlib import sha256
-from .confManager import ConfManager
+from hydrapaper.confManager import ConfManager
 from pathlib import Path
 from threading import Thread
 
diff --git a/hydrapaper/wallpaper_merger.py b/hydrapaper/wallpaper_merger.py
index bb4b269..c6e17cb 100644
--- a/hydrapaper/wallpaper_merger.py
+++ b/hydrapaper/wallpaper_merger.py
@@ -4,7 +4,7 @@ from PIL.ImageFilter import GaussianBlur
 from os import environ as Env
 from subprocess import run
 import re
-from .confManager import ConfManager
+from hydrapaper.confManager import ConfManager
 # from .set_wallpaper_portal import set_wallpaper
 
 SWAY_CONF_PATH = f'{Env.get("HOME")}/.config/sway/config'
diff --git a/hydrapaper/wallpapers_flowbox.py b/hydrapaper/wallpapers_flowbox.py
index 5bc12b9..17974a2 100644
--- a/hydrapaper/wallpapers_flowbox.py
+++ b/hydrapaper/wallpapers_flowbox.py
@@ -1,7 +1,7 @@
 from gi.repository import Gtk
-from .confManager import ConfManager
-from .wallpaper_flowbox_item import WallpaperBox
-from .search_bar import HpSearchBar
+from hydrapaper.confManager import ConfManager
+from hydrapaper.wallpaper_flowbox_item import WallpaperBox
+from hydrapaper.search_bar import HpSearchBar
 import pathlib
 
 
diff --git a/hydrapaper/wallpapers_folder_listbox_row.py b/hydrapaper/wallpapers_folder_listbox_row.py
index 78eefa3..5db1d79 100644
--- a/hydrapaper/wallpapers_folder_listbox_row.py
+++ b/hydrapaper/wallpapers_folder_listbox_row.py
@@ -1,6 +1,6 @@
 from gi.repository import Gtk
-from .folder_store import FolderObj
-from .confManager import ConfManager
+from hydrapaper.folder_store import FolderObj
+from hydrapaper.confManager import ConfManager
 
 
 class WallpapersFolderListBoxRow(Gtk.ListBoxRow):
diff --git a/hydrapaper/wallpapers_folders_view.py b/hydrapaper/wallpapers_folders_view.py
index 040bcfb..764edd6 100644
--- a/hydrapaper/wallpapers_folders_view.py
+++ b/hydrapaper/wallpapers_folders_view.py
@@ -1,10 +1,10 @@
 from gettext import gettext as _
 from pathlib import Path
 from gi.repository import Gtk
-from .folder_store import FolderObj
-from .folder_store import FolderStore
-from .confManager import ConfManager
-from .wallpapers_folder_listbox_row import WallpapersFolderListBoxRow
+from hydrapaper.folder_store import FolderObj
+from hydrapaper.folder_store import FolderStore
+from hydrapaper.confManager import ConfManager
+from hydrapaper.wallpapers_folder_listbox_row import WallpapersFolderListBoxRow
 from os.path import isdir
 
 
diff --git a/meson.build b/meson.build
index f55d1df..7702b6e 100644
--- a/meson.build
+++ b/meson.build
@@ -76,13 +76,7 @@ app_id_aspath = '/'.join([
     meson.project_name()
 ])
 
-enable_daemon = get_option('enabledaemon')
-message(f'Daemon Enabled: @enable_daemon@')
-
 install_subdir(meson.project_name(), install_dir: pythondir)
-if enable_daemon == true
-    subdir('hydrapaper_daemon')
-endif
 subdir('data')
 subdir('bin')
 subdir('po')
diff --git a/pyproject.toml b/pyproject.toml
new file mode 100644
index 0000000..615ac50
--- /dev/null
+++ b/pyproject.toml
@@ -0,0 +1,16 @@
+[tool.poetry]
+name = "hydrapaper"
+version = "3.3.1"
+description = "Wallpaper manager with multimonitor support"
+authors = ["Gabriele Musco <gabmus@disroot.org>"]
+license = "GPL-3.0+"
+readme = "README.md"
+
+[tool.poetry.dependencies]
+python = "^3.10"
+Pillow = "^9.5.0"
+dbus-python = "1.2.18"
+
+[build-system]
+requires = ["poetry-core"]
+build-backend = "poetry.core.masonry.api"
-- 
2.40.1

